package com.pj.listentwo;

import cn.hutool.core.util.RandomUtil;
import com.alibaba.fastjson.JSONObject;
import com.pj.bank_byte.BankByte;
import com.pj.bank_byte.BankByteMapper;
import com.pj.dto.DataDto;
import com.pj.enummj.FinishStatus;
import com.pj.rabbitmqtwo.RabbitMQTwo;
import com.pj.utils.ht.AESUtil;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.annotation.Queue;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;

@Component
public class BaseInfoListenTwo {


    @Autowired
    private BankByteMapper bankByteMapper;

    /**
     * 监听: 接收并保存银行回执信息
     * @param json
     */
    @RabbitListener(queuesToDeclare = @Queue(RabbitMQTwo.TEST_ACCEPT_QUEUE))
    public void accept(Message json){
        System.out.println("-----------------开始接收:银行回执信息------------------------");
        byte[] content = json.getBody();
        //保存到数据库
        String jsonString = new String(content);
        bankByteMapper.insert(new BankByte(RandomUtil.randomString(64),jsonString, RabbitMQTwo.TEST_ACCEPT_QUEUE, FinishStatus.FINISH_STATUS_ZERO.getCode(),new Date()));
        System.out.println("-----------------完成接收:银行回执信息------------------------");

    }


    /**
     * 测试接收
     * 测试已通过
     */
    @RabbitListener(queuesToDeclare = @Queue(RabbitMQTwo.TEST_SEND_QUEUE))
    public void sendMessage(Message dataDto1){
        System.out.println("---------开始发送:银行接口报文-----------------");
        byte[] body = dataDto1.getBody();
        String s = new String(body);
        DataDto dataDto = JSONObject.parseObject(s, DataDto.class);
        //String cbc = AESUtil.decryptCBC(dataDto.getData(), RabbitMQOne.ACC_KEY);
        //OrderDto orderDto = JSONObject.parseObject(cbc, OrderDto.class);
        System.out.println(dataDto.getData() + "\n---------结束发送:银行接口报文-----------------");
    }

}
